' ToBE.VBS V1.03 (C) yoshioka.teruo@nifty.com 2006-04-04
' ToBE.VBS converts files to Unicode Big Endian.
' Usage: Start ToBE.vbs files...

Option Explicit
Dim fso
Dim Path
Dim StdIn
Dim StdOut
Dim tPath
Dim FolderName
Dim FileName
Dim BaseName
Dim File
Dim n
Dim tName

Set fso=CreateObject("Scripting.FileSystemObject")

For Each Path In WScript.Arguments
  Set StdIn=OpenTextFile(fso,Path)
  FolderName=fso.GetParentFolderName(Path)
  FileName=fso.GetFileName(Path)
  BaseName=fso.GetBaseName(Path)
  tPath=fso.BuildPath(FolderName,fso.GetTempName)
  fso.CreateTextFile(tPath).Write Chr(&HFE) & Chr(&HFF)
  Set StdOut=fso.OpenTextFile(tPath,8,,True)
  Call Process(StdIn,StdOut)
  StdIn.Close
  StdOut.Close

  Set File=fso.GetFile(Path)
  For n=1000 To 1999
    tName=BaseName & "." & Right(n,3)
    Call Rename(File,tName)
    If Err=0 Then
      Exit For
    ElseIf Err<>58 Then
      WScript.Echo Err.Number & " : " & Err.Description
      WScript.Quit
    End If
  Next
  WScript.Echo FileName & " -> " & tName

  Set File=fso.GetFile(tPath)
  Call Rename(File,FileName)
  If Err<>0  Then
    WScript.Echo Err.Number & ":" & Err.Description
    WScript.Quit
  End If
Next
If WScript.Arguments.Count=0 Then
  WScript.Echo "Usage: Start ToBE.VBS files..."
End If
WScript.Quit

Function OpenTextFile(fso,File)
Dim fUNICODE
Dim BOM
BOM=fso.OpenTextFile(File).Read(2)
fUNICODE=BOM=Chr(&HFF)&Chr(&HFE) Or BOM=Chr(&HFE)&Chr(&HFF)
Set OpenTextFile=fso.OpenTextFile(file,,,fUNICODE)
End Function

Sub Rename(File,Name)
On Error Resume Next
File.Name=Name
End Sub

Sub Process(StdIn,StdOut)
Dim Line

Do While Not StdIn.AtEndOfStream
  Line=ReadLine(StdIn)
  StdOut.Write Line&vbCrLf
Loop
End Sub

Function ReadLine(File)
Dim Line
Dim Char
Do While Not File.AtEndOfStream
  Char=File.Read(1)
  If Char=vbLf Then Exit Do
  Line=Line & Char
Loop
Do While Right(Line,1)=vbCr
  Line=Left(Line,Len(Line)-1)
Loop
ReadLine=Replace(Line,vbNullChar,"")
End Function
