' ucs2sjis.VBS V1.03 (C) yoshioka.teruo@nifty.com 2006-04-04
' ucs2sjis.VBS converts Unicode to Shift JIS.
' Usage: Start ucs2sjis.vbs files...
' Usage: CScript.exe //NoLogo ucs2sjis.vbs [<input] [>output]

Option Explicit
Dim fso
Dim Path
Dim StdIn
Dim StdOut
Dim tPath
Dim FolderName
Dim FileName
Dim BaseName
Dim File
Dim n
Dim tName

Set fso=CreateObject("Scripting.FileSystemObject")

For Each Path In WScript.Arguments
  Set StdIn=fso.OpenTextFile(Path,,,True)
  FolderName=fso.GetParentFolderName(Path)
  FileName=fso.GetFileName(Path)
  BaseName=fso.GetBaseName(Path)
  tPath=fso.BuildPath(FolderName,fso.GetTempName)
  Set StdOut=fso.CreateTextFile(tPath)
  Call Process(StdIn,StdOut)
  StdIn.Close
  StdOut.Close

  Set File=fso.GetFile(Path)
  For n=1000 To 1999
    tName=BaseName & "." & Right(n,3)
    Call Rename(File,tName)
    If Err=0 Then
      Exit For
    ElseIf Err<>58 Then
      WScript.Echo Err.Number & " : " & Err.Description
      WScript.Quit
    End If
  Next
  WScript.Echo FileName & " -> " & tName

  Set File=fso.GetFile(tPath)
  Call Rename(File,FileName)
  If Err<>0  Then
    WScript.Echo Err.Number & ":" & Err.Description
    WScript.Quit
  End If
Next
If WScript.Arguments.Count=0 Then
  If LCase(fso.GetBaseName(WScript.FullName))="cscript" Then
    Call Process(fso.GetStandardStream(0,True),fso.GetStandardStream(1))
  Else
    WScript.Echo "Usage: Start ucs2sjis.vbs files..."
    WScript.Quit
  End If
End If
WScript.Quit

Sub Rename(File,Name)
On Error Resume Next
File.Name=Name
End Sub

Sub Process(StdIn,StdOut)
Dim Line
Dim Char
Dim k

Do While Not StdIn.AtEndOfStream
  Line=ReadLine(StdIn)
  On Error Resume Next
  StdOut.WriteLine Line
  If Err<>0 Then
    On Error GoTo 0
    For k=1 To Len(Line)
      Char=Mid(Line,k,1)
      On Error Resume Next
      StdOut.Write Char
      If Err<>0 Then
        On Error GoTo 0
        StdOut.Write Escape(Char)
      Else
        On Error GoTo 0
      End If
    Next
    StdOut.WriteLine ""
  Else
    On Error GoTo 0
  End If
Loop
End Sub

Function ReadLine(File)
Dim Line
Dim Char
Do While Not File.AtEndOfStream
  Char=File.Read(1)
  If Char=vbLf Then Exit Do
  Line=Line & Char
Loop
Do While Right(Line,1)=vbCr
  Line=Left(Line,Len(Line)-1)
Loop
ReadLine=Replace(Line,vbNullChar,"")
End Function
